Ruby - Bug #14406

File.expand_path doesn't expand tilde inside Windows home directory

01/26/2018 04:29 PM - abotalov (Andrei Botalov)

Status: Rejected
Priority: Normal
Assignee:

Target version:

ruby -v: 2.5.0 Backport:

2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:

Description

TMP environment variable on Windows is set to a name that contains a tilde. File.expand_path doesn't currently return an expanded

name. | would expect it to do so as its documentation says:
"Converts a pathname to an absolute pathname."

"The given pathname may start with a “~”, which expands to the process owner's home directory"

Example on my system:

irb(main) :085:0> File.expand_path (Dir.tmpdir)
=> "C:/Users/ANDREI~1/AppData/Local/Temp"
irb(main) :086:0> File.absolute_path(Dir.tmpdir)
=> "C:/Users/ANDREI~1/AppData/Local/Temp"

History

#1 - 01/26/2018 04:42 PM - Hanmac (Hans Mackowiak)

you are wrong it means something different:

File.expand_path("~") #=> "C:/Users/h.mackowiak"

you thing are FAT paths which got that shortage because of "8.3 filename
https://en.wikipedia.org/wiki/8.3_filename

ruby might not be able to do much about that

#2 - 01/27/2018 05:45 AM - nobu (Nobuyoshi Nakada)
- Description updated

- Status changed from Open to Rejected

abotalov (Andrei Botalov) wrote:

TMP environment variable on Windows is set to a name that contains a tilde.

"Containing" doesn't mean "starting with".

irb (main) :085:0> File.expand_path (Dir.tmpdir)
=> "C:/Users/ANDREI~1/AppData/Local/Temp"
irb(main) :086:0> File.absolute_path (Dir.tmpdir)
=> "C:/Users/ANDREI~1/AppData/Local/Temp"

These contain a tilde, but do not start with.

#3 - 01/29/2018 09:38 AM - Hanmac (Hans Mackowiak)
@abotalov:

you need to call GetLongPathName https:/msdn.microsoft.com/en-us/library/windows/desktop/aa364980(v=vs.85).aspx

using win32api or fiddle
the win32api would look like that:

require "tmpdir"
def get_long_win32_filename (short_name)
https://en.wikipedia.org/wiki/8.3_filename
https://msdn.microsoft.com/en-us/library/windows/desktop/aa364980(v=vs.85).aspx

require 'win32api'

win_func = Win32API.new("kernel32", "GetLongPathName", "PPL","L")
buf = 0.chr * 256

buf[0..short_name.length-1] = short_name

win_func.call (short_name, buf, buf.length)

return buf.split (0.chr).first

end
p get_long_win32_filename (Dir.tmpdir)

don't know how much complicated it would be with fiddle

#4 - 01/29/2018 06:40 PM - davispuh (Davis Mosans)
| wrote a patch for this with #12656
https://bugs.ruby-lang.org/issues/12656
http://www.tcpdf.org

